(function(){
	var win = window;
	var doc = win.document;
	var contracted=true;
	var tmoId = -1,tmoId2=-1,tmoId3=-1;
	ADTECH.ready(function(){
		var vid = doc.querySelector('.expanded>video');
		var cls = doc.querySelectorAll('.closeBtn');
		var clc = doc.querySelectorAll('.clickLayer');
		var expElm = doc.querySelector('.expanded');
		var contElm = doc.querySelector('.contracted');
		var ply = doc.querySelector('.playButton');
		ADTECH.registerVideoPlayer(vid);
		vid.onended = function(){
			expElm.classList.add('videoComplete');
			expElm.classList.remove('videoPlaying');
		}
		vid.onplaying = function(){
			expElm.classList.remove('videoComplete');
			expElm.classList.add('videoPlaying');
		}
		
		//define interactions
		for(var i=0;i<cls.length;i++){
			if(cls[i].classList.contains('contract')){
				cls[i].onclick = function(){
					doContract();
				}
			}else{
				cls[i].onclick = function(){
					ADTECH.close();
				}
			}
		}
		if(ply != null){
			ply.onclick = function(){
				vid.play();
			}
		}
		!function(){
			var overCnt=0;
			expElm.onmouseover = contElm.onmouseover = function(){
				overCnt++;
				clearTimeout(tmoId3);				
				if(contracted){
					clearTimeout(tmoId);
					tmoId = setTimeout(doExpand,750);
				}
			}
			expElm.onmouseout = contElm.onmouseout = function(){				
				if(!contracted && overCnt == 1){
					clearTimeout(tmoId3);
					tmoId3 = setTimeout(doContract,750);
				}
				overCnt--;
				
			}
		}();
		
		//define clicks
		for(var i=0;i<clc.length;i++){
			clc[i].onclick = function(e){
				if(e.target.parentNode != doc.body){
					if(e.target.parentNode.classList.contains('expanded')){
						ADTECH.click('expanded');
						return;
					}else if(e.target.parentNode.classList.contains('contracted')){
						ADTECH.click('contracted');
						return;
					}
				}				
				ADTECH.click('general');
			}			
		}
		function doContract(){
			if(contracted) return;
			contracted =true;
			ADTECH.ready(function(){
				clearTimeout(tmoId2);
				tmoId2 = setTimeout(function(){
					ADTECH.contract();
				},700);
			});
			
			//pause the video and hide it
			if(vid != null){
				vid.pause();			
			}
			doc.body.classList.remove('expanded');
		}
		function doExpand(){
			if(!contracted) return;
			contracted =false;
			clearTimeout(tmoId2);
			ADTECH.ready(function(){
				ADTECH.expand();	
			});
			doc.body.classList.add('expanded');
			vid.play();
			vid.currentTime = 0;
		}
				
		//on mouse over, start the timer to expand
		ADTECH.addEventListener(com.adtech.RichMediaEvent.MOUSE_OVER, function(e){
			clearTimeout(tmoId);
			if(contracted){
				tmoId = setTimeout(doExpand,750);
			}
		});
		//on mouse out, cancel the expand timer
		ADTECH.addEventListener(com.adtech.RichMediaEvent.MOUSE_OUT, function(e){
			clearTimeout(tmoId);
		});
	});
})();